<template>
  <v-card>
    <v-card-title class="title">
      Accumulated Label Statistics
    </v-card-title>
    <v-data-table
      :headers="headers"
      :items-per-page="-1"
      sort-by="count"
      sort-desc
      :loading="loading"
      :items="summedLabelCounts"
      hide-default-footer
    />

    <div
      v-for="([subType, labelCounts]) in mappedLabelCounts"
      :key="subType"
    >
      <v-card-title class="title">
        Statistics for: {{ subType }}
      </v-card-title>
      <v-data-table
        :headers="headers"
        :items-per-page="-1"
        sort-by="count"
        sort-desc
        :loading="loading"
        :items="labelCounts"
        hide-default-footer
      />
    </div>
  </v-card>
</template>


<script lang="ts">
import Vue from 'vue'
import Component from 'vue-class-component'
import * as api from '@/api'
import { LabelStatisticsForSubType, SubmissionType} from '../models'
import { getters } from '../store/getters'
import { FeedbackLabels } from '../store/modules/feedback-labels'
import { ConfigModule } from '@/store/modules/config'


@Component
export default class LabelStatistics extends Vue{
  labelStatistics: LabelStatisticsForSubType[] = []
  submissionTypes: SubmissionType[] = []
  timer = 0

  headers = [
    {
      text: 'Label',
      align: 'left',
      value: 'name'
    },
    {
      text: 'Count',
      align: 'center',
      value: 'count'
    }
  ]

  get loading(): boolean {
    return this.labelStatistics.length === 0
  }

  /**
   * Returns total count for all existing labels for the currently selected exam
   */
  get summedLabelCounts () {
    // list of subtype IDs filtered by the selected exam
    const subTypeIDs = this.submissionTypes.filter(subType => {
      return subType.examType.pk === ConfigModule.state.config.examId
    }).map(subType => {
      return subType.pk
    })
    // filter the statistics
    const filteredStatistics = this.labelStatistics.filter(subType => {
      return subTypeIDs.includes(subType.pk)
    })
    const summedLabelCounts = filteredStatistics
    .reduce((acc: {[labelPk: string]: number}, curr) => {
      Object.entries(curr)
        .filter(([key, val]) => key !== 'pk')
        .forEach(([labelPk, count]: [string, number]) => {
          if (!acc[labelPk]) {
            acc[labelPk] = 0
          }
          acc[labelPk] += count
        })
      return acc
    }, {})
    // TODO map label pks to names
    const mappedLabelCounts = this.mapLabelList(Object
      .entries(summedLabelCounts))
    return mappedLabelCounts
  }

  /**
   *
   * Returns Label Names and number of occurances for each Submission Type of the currently selected Exam.
   */
  get mappedLabelCounts () {
    var allowedTypes: string[] = []   // needed to filter if submissionType belongs to current selected Exam
    const counts = this.labelStatistics.map(labelStatistics => {
      const labelValues = Object
        .entries(labelStatistics)
        .filter(([key, val]) => key !== 'pk')
      const subType = getters.submissionType(labelStatistics.pk)

      // determine which submissionTypes belong to current selected exam
      if (subType.examType.moduleReference === ConfigModule.state.config.currentExam) {
        allowedTypes.push(subType.name)
      }

      const subTypeName = subType.name
      return [subTypeName, this.mapLabelList(labelValues)]
      // it seems the typechecker has a bug here...
    }).sort((a: any, b: any) => a[0].localeCompare(b[0]))
    return counts.filter(tmp => {   // filter submissionTypes by current selected Exam
      return allowedTypes.includes(tmp[0].toString())
    })
  }

  mapLabelList (labelList: [string, number][]) {
    return labelList.map(entry => {
        const label = FeedbackLabels.state.labels.find(label => {
          return String(label.pk) === entry[0]
        })
        const labelName = label ? label.name : 'Unknown label'
        return {name: labelName, count: entry[1]}
      })
  }

  async loadLabelStatistics () {
    this.labelStatistics = await api.fetchLabelStatistics()
  }

  async loadSubmissionTypes () {
    this.submissionTypes = await api.fetchSubmissionTypes()
  }

  created () {
    this.timer = setInterval(() => {
      this.loadLabelStatistics()
    }, 10 * 1e3)
    this.loadLabelStatistics()
    this.loadSubmissionTypes()
  }

  beforeDestroy () {
    clearInterval(this.timer)
  }

}
</script>
